				PCPWM_Page	;   PCPWM
;  PC_PWM   
;  3    3   PWM  4431
;   IRAMX16UP60A  .
;  , / ,
;   . 
;17.1 Control Registers ;The operation of the PWM module is controlled by a
;total of 22 registers. Eight of these are used to
;configure the features of the module:
; PWM Timer Control register 0 (PTCON0)
; PWM Timer Control register 1 (PTCON1)
; PWM Control register 0 (PWMCON0)
; PWM Control register 1 (PWMCON1)
; Dead Time Control register (DTCON)
; Output Override Control register (OVDCOND)
; Output State register (OVDCONS)
; Fault Configuration register (FLTCONFIG)
;There are also 14 registers that are configured as
;seven register pairs of 16 bits. These are used for the
;configuration values of specific features. They are:
; PWM Time Base Registers (PTMRH and PTMRL)
; PWM Period Registers (PTPERH and PTPERL)
; PWM Special Event Compare Registers
;(SEVTCMPH and SEVTCMPL)
; PWM Duty Cycle #0 Registers
;(PDC0H and PDC0L)
; PWM Duty Cycle #1 Registers
;(PDC1H and PDC1L)
; PWM Duty Cycle #2 Registers
;(PDC2H and PDC2L)
; PWM Duty Cycle #3 registers
;(PDC3H and PDC3L)
;All of these register pairs are double-buffered.

	CLRF PDC0H,ACCESS ;   
	movlf	0x1F,PDC0L,ACCESS ; Period/PWM Freq Set
	CLRF PDC1H,ACCESS ;   
	movlf	0x1F,PDC1L,ACCESS ; Period/PWM Freq Set
	CLRF PDC2H,ACCESS ;   
	movlf	0x1F,PDC2L,ACCESS ; Period/PWM Freq Set


;     
;  IRAMX16UP60A     48/4096=11718,75    .
; AN955   - UP/Down  .
;   - PTPER=0x1FF  11    11.7 .
;    11.7  23.4    
; DUTY CYCLE UPDATE TIMES IN UP/DOWN COUNTING MODE WITH DOUBLE UPDATES

;	CLRF PTPERH,ACCESS ; ; 48 MHz 12 MIPS 1FFh 11 bits 11.7/23.4 kHz
;	INCF PTPERH,F,ACCESS ;  -    
;	INCF PTPERH,F,ACCESS ;      
;	INCF PTPERH,F,ACCESS ; --    .
;	movlf	0x01,PTPERH,ACCESS	; 0x1FF = 11 bits 11.718/23.4 kHz    
;****************
;	movlf	0x03,PTPERH,ACCESS	; 0x3FF = 12 bits 5.859/11.718 kHz    
;	setf PTPERL,ACCESS ; Period/PWM Freq Set 
;  PTPER  4   PDC.
;     DTCon (  ~0.1     DTCon)
; -    PDC = 
;  = DtCon+1,  = PtPer*4-DtCon-FloatChargeTime
;    -        ,
;   -  2-3 .  DT = 2   STK_621_061_E -  6-8 
;    .
;         :
; 1. PTPER-16,	2. PDC_Max-16 	3. PDC_Min-8 -    
; 4.   -16	5.   -16
; 6. PCPWM_MK1+1 ; .     12 
; 10    16  = 160   + 3    4  (45-72-90-120 ). 	 
#ifdef	PCPWM_FreqHi 	; 11.7   , 11  - 
	movlf	0x02,PTPERH,ACCESS	; -    
 movlf	0xA,PCPWM_MK1+1,BANKED; .     12  	 

 #else	;  5.8 , 12  - 
	movlf	0x0F,PTPERH,ACCESS	; -     
 movlf	0x14,PCPWM_MK1+1,BANKED; .     13 	 
 ;movlf	0x0A,PCPWM_MK1+1,BANKED; .     12 	 
 ;movlf	0x05,PCPWM_MK1+1,BANKED; .     11 	 
 #endif
;	movlf	0x4,PTPERL,ACCESS ; .      . 
	movlf	0xFF,PTPERL,ACCESS ; .      . 
    movlf	0x00,PCPWM_MK1+0,BANKED;      

; *******         *******.
;     FXM1680U  ?
; 1616=32   16    .65536-13107=52 428 :
;  14    16384  -  = 10240=0x2800,  2 418   0x804 
;  13    8 192  -  = 5120=0x1400,  5 836.6   0x404
;  12    4 096  -  = 2560=0xA00,  11 628   0x204
;  11    2 048  -  = 1280=0x500,  23 076   0x104
;  10    1 024  -  = 640=0x280,  ~46    0x84
; 02/10/2018    0xA00   0x204 -   ,
; -      .


;REGISTER 17-1: PTCON0: PWM TIMER CONTROL REGISTER 0
;bit 7-4 PTOPS3:PTOPS0: PWM Time Base Output Postscale Select bits
;0000 =1:1 Postscale ;0001 =1:2 Postscale ..... ;1111 =1:16 Postscale 
;bit 3-2 PTCKPS1:PTCKPS0: PWM Time Base Input Clock Prescale Select bits
;00 =PWM time base input clock is Fosc/4 (1:1 prescale)
;01 =PWM time base input clock is Fosc/16 (1:4 prescale)
;10 =PWM time base input clock is Fosc/64 (1:16 prescale)
;11 =PWM time base input clock is Fosc/256 (1:64 prescale)
;bit 1-0 PTMOD1:PTMOD0: PWM Time Base Mode Select bits
;11 =PWM time base operates in a Continuous Up/Down mode with interrupts for double PWM
;updates.
;10 =PWM time base operates in a Continuous Up/Down Counting mode.
;01 =PWM time base configured for Single-shot mode.
;00 =PWM time base operates in a Free Running mode.
	clrf PTCON0,ACCESS	;   
	bsf  PTCON0,PTMOD1,ACCESS ; PTMOD1:PTMOD0:
;           -    
;	bsf  PTCON0,PTMOD0,ACCESS ; PTMOD1:PTMOD0:  23    .
	; 10 =PWM time base operates in a Continuous Up/Down Counting mode.
;REGISTER 17-2: PTCON1: PWM TIMER CONTROL REGISTER 1
;bit 7 PTEN: PWM Time Base Timer Enable bit
;1 = PWM time base is ON
;0 = PWM time base is OFF
;bit 6 PTDIR: PWM Time Base Count Direction Status bit
;1 = PWM time base counts down.
;0 = PWM time base counts up.
;bit 5-0 Unimplemented: Read as 0.
	clrf PTCON1,ACCESS			;   
	bsf  PTCON1,PTEN,ACCESS ;1 = PWM time base is ON
;REGISTER 17-3: PWMCON0: PWM CONTROL REGISTER 0
;bit 7 Unimplemented: Read as 0.
;bit 6-4 PWMEN2:PWMEN0: PWM Module Enable bits(1)
;111 =All odd PWM I/O pins enabled for PWM output(2).
;110 =PWM1, PWM3 pins enabled for PWM output.
;101 =All PWM I/O pins enabled for PWM output(2) .
;100 =PWM0, PWM1, PWM2, PWM3, PWM4 and PWM5 pins enabled for PWM output.
;011 =PWM0, PWM1, PWM2 and PWM3 I/O pins enabled for PWM output.
;010 =PWM0 and PWM1 pins enabled for PWM output.
;001 =PWM1 pin is enabled for PWM output.
;000 =PWM module disabled. All PWM I/O pins are general purpose I/O.
;bit 3-0 PMOD3:PMOD0: PWM Output Pair Mode bits
;For PMOD0:
;1 = PWM I/O pin pair (PWM0, PWM1) is in the Independent mode.
;0 = PWM I/O pin pair (PWM0, PWM1) is in the Complementary mode.
;For PMOD1:
;1 = PWM I/O pin pair (PWM2, PWM3) is in the Independent mode.
;0 = PWM I/O pin pair (PWM2, PWM3) is in the Complementary mode.
;For PMOD2:
;1 = PWM I/O pin pair (PWM4, PWM5) is in the Independent mode.
;0 = PWM I/O pin pair (PWM4, PWM5) is in the Complementary mode.
;For PMOD3(3):
;1 = PWM I/O pin pair (PWM6, PWM7) is in the Independent mode.
;0 = PWM I/O pin pair (PWM6, PWM7) is in the Complementary mode.
	clrf PWMCON0,ACCESS			;   
	;bsf  PWMCON0,PWMEN1,ACCESS ;;010 =PWM0 and PWM1 pins enabled for PWM output.
;	bsf  PWMCON0,PWMEN2,ACCESS ;;100 =PWM0, PWM1, PWM2, PWM3, PWM4 and PWM5 pins enabled for PWM output.
 PWM_Start	;    
	;bsf  PWMCON0,PMOD0,ACCESS ;;1 = PWM I/O pin pair (PWM0, PWM1) is in the Independent mode.
	;bsf  PWMCON0,PMOD1,ACCESS ;;1 = PWM I/O pin pair (PWM2, PWM3) is in the Independent mode.
	;bsf  PWMCON0,PMOD2,ACCESS ;;1 = PWM I/O pin pair (PWM4, PWM5) is in the Independent mode.

;REGISTER 17-4: PWMCON1: PWM CONTROL REGISTER 1
	clrf PWMCON1,ACCESS			;   
;bit 7-4 SEVOPS3:SEVOPS0: PWM Special Event Trigger Output Postscale Select bits
;0000 =1:1 Postscale ;0001 =1:2 Postscale ..... ;1111 =1:16 Postscale
;bit 3 SEVTDIR: Special Event Trigger Time Base Direction bit
;1 = A special event trigger will occur when the PWM time base is counting downwards.
;0 = A special event trigger will occur when the PWM time base is counting upwards.
;bit 2 Unimplemented: Read as 0.
;bit 1 UDIS: PWM Update Disable bit
;1 = Updates from duty cycle and period buffer registers are disabled.
;0 = Updates from duty cycle and period buffer registers are enabled.
;bit 0 OSYNC: PWM Output Override Synchronization bit
;1 = Output overrides via the OVDCON register are synchronized to the PWM time base.
;0 = Output overrides via the OVDCON register are asynchronous.

;REGISTER 17-5: DTCON  DEAD TIME CONTROL REGISTER
;	clrf DTCON,ACCESS			;   
;bit 7-6 DTPS1:DTPS0: Dead Time Unit A Prescale Select bits
;11 = Clock source for Dead Time Unit is FOSC/16.
;10 = Clock source for Dead Time Unit is FOSC/8.
;01 = Clock source for Dead Time Unit is FOSC/4.
;00 = Clock source for Dead Time Unit is FOSC/2.
;bit 5-0 DT5:DT0: Unsigned 6-bit dead time value bits for Dead Time Unit.
	movlf	0x18,DTCON,ACCESS	;  1     48/2 

;REGISTER 17-6: OVDCOND: OUTPUT OVERRIDE CONTROL REGISTER
;R/W-1 R/W-1 R/W-1 R/W-1 R/W-1 R/W-1 R/W-1 R/W-1
;POVD7(1) POVD6(1) POVD5 POVD4 POVD3 POVD2 POVD1 POVD0
;bit 7-0 POVD7:POVD0: PWM Output Override bits(1)
;1 = Output on PWM I/O pin is controlled by the value in the Duty Cycle register and the PWM
;time base.
;0 = Output on PWM I/O pin is controlled by the value in the corresponding POUT bit.	
	setf OVDCOND,ACCESS			;   
	clrf OVDCONS,ACCESS			;   

;REGISTER 17-8: FLTCONFIG: FAULT CONFIGURATION REGISTER
;R/W-0 R/W-0 R/W-0 R/W-0 R/W-0 R/W-0 R/W-0 R/W-0
;BRFEN FLTBS(1) FLTBMOD(1) FLTBEN(1) FLTCON FLTAS FLTAMOD FLTAEN
;bit 7 BRFEN: Breakpoint Fault Enable bit
;1 = Enable fault condition on a breakpoint (i.e., only when HDMIN = 1)
;0 = Disable fault condition
;bit 6 FLTBS: Fault B Status bit(1)
;1 = FLTB is asserted;
;if FLTBMOD = 0, cleared by the user
;if FLTBMOD = 1, cleared automatically at beginning of the new period when FLTB is
;deasserted
;0 = No Fault
;bit 5 FLTBMOD: Fault B Mode bit(1)
;1 = Cycle-by-cycle mode: Pins are inactive for the remainder of the current PWM period, or until
;FLTB is deasserted. FLTBS is cleared automatically when FLTB is inactive (no fault present).
;0 = Inactive mode: Pins are deactivated (catastrophic failure) until FLTB is deasserted and
;FLTBS is cleared by the user only.
;bit 4 FLTBEN: Fault B Enable bit(1)
;1 = Enable Fault B
;0 = Disable Fault B
;bit 3 FLTCON: Fault Configuration bit
;1 = FLTA , FLTB or both deactivates all PWM outputs
;0 = FLTA or FLTB deactivates PWM[5:0]
;bit 2 FLTAS: Fault A Status bit
;1 = FLTA is asserted;
;If FLTAMOD = 0, cleared by the user
;If FLTAMOD = 1, cleared automatically at beginning of the new period when FLTA is
;deasserted.
;0 = No Fault
;bit 1 FLTAMOD: Fault A Mode bit
;1 = Cycle-by-cycle mode: Pins are inactive for the remainder of the current PWM period, or until
;FLTA is deasserted. FLTAS is cleared automatically.
;0 = Inactive mode: Pins are deactivated (catastrophic failure) until FLTA is deasserted and
;FLTAS is cleared by the user only.
;bit 0 FLTAEN: Fault A Enable bit
;1 = Enable Fault A
;0 = Disable Fault A
;
	clrf FLTCONFIG,ACCESS			;   

; movlf	0x15,PCPWM_Speed,BANKED	;  
; movlf	0x85,PCPWM_Amp,BANKED	;  		 
	
 clrf	PCPWM_Err,ACCESS	;   
;	movlb	0x0	; BSR  Bank-1 for PCPWM 
 ;clrf	PCPWM_Ang1,BANKED;	:2	;      BANK 0
 ;clrf	PCPWM_Ang1+1,BANKED;	:2	;      BANK 0
	PCPWM_Page
	clrf	PCPWM_Flag2,ACCESS		;
 btg PCPWM_Flag2,1,ACCESS;1=       
	clrf	PCPWM_Flag1,ACCESS		;
	clrf	PCPWM_Flag,ACCESS		;

	clrf	PCPWM_SpCh_Route,BANKED	;
	movlf	WorkSubStr,PCPWM_Alarm_Route,BANKED;   
 	clrf	PCPWM_SpdCount,BANKED
	clrf	PCPWM_SpdCount+1,BANKED	;
	clrf	PCPWM_AnimeCount,BANKED	;   
 movlf	d'13',PCPWM_AnimeSubStr,BANKED	;
 movlf	d'8',PCPWM_StartStop,BANKED		;
 movlf	d'10',PCPWM_ForwardReverse,BANKED;
 movlf	d'10',PCPWM_AccelProt,BANKED;   /   
 movff PCPWM_AccelProt,PCPWM_AccProtBuf	;
; movlf	d'1',PcPwmAngInd,BANKED;    	
; movlf	d'10',PcPwmFrqInd,BANKED;    0-20, 6074  = 10 ,12  
 		;setf	PcFrqIndOld,BANKED;     0-20, 0xFF =  


	clrf	PCPWM_WorkSpeed,BANKED;     .
 #ifdef __DEBUG
	bsf	PCPWM_Flag,3,ACCESS		; /
 ;call StopMotor	; 
 #else
	bcf	PCPWM_Flag,3,ACCESS		; /
 call StopMotor	; 
 #endif
;   
	bsf		IPR3,PTIP,ACCESS		;  /
	bcf		PIR3,PTIF,ACCESS		;   
	bcf		PIE3,PTIE,ACCESS		;   - PCPWM

	btfsc	RCON,3,ACCESS	;   ?
 bra NotWdtReset
 	bsf PCPWM_Flag1,3,ACCESS;3= 0=     50 ,
;      /   
	movlf	d'18',PCPWM_Alarm_Route,BANKED;    - 18 
NotWdtReset
;	return
; PTMOD ???	
;This mode is available in Up/Down Counting mode. In
;the Double Update mode (PTMOD<1:0> = 11),
;Do not change PTMOD while PTEN is
;active. It will yield unexpected results. To
;change PWM Timer mode of operation,
;first clear PTEN bit, load PTMOD with
;required data and then set PTEN.